#ifndef EFL_GENERATED_ECORE_PARENT_HH
#define EFL_GENERATED_ECORE_PARENT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_parent.eo.h"
}

#include "eo_base.eo.hh"

namespace ecore {

struct parent;

}

namespace eo_cxx {

namespace ecore {

struct parent
{

   static Eo_Class const* _eo_class()
   {
      return(ECORE_PARENT_CLASS);
   }

   operator ::ecore::parent() const;
   operator ::ecore::parent&();
   operator ::ecore::parent const&() const;

   template <typename D>
   struct address_of
   {
      operator ::ecore::parent*() const { return static_cast<::ecore::parent*>(static_cast<D const*>(this)->p); }
      operator ::ecore::parent const*() const { return static_cast<::ecore::parent const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::ecore::parent const*() const { return static_cast<::ecore::parent const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace ecore {

struct parent
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
{
   parent(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : parent(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit parent(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit parent(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   parent(parent const& other)
      : parent(eo_ref(other._eo_ptr()))
   {}

   ~parent() {}


   static Eo_Class const* _eo_class()
   {
      return(ECORE_PARENT_CLASS);
   }

   struct address_of
      : ::eo_cxx::ecore::parent::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::ecore::parent* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::ecore::parent::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::ecore::parent const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ECORE_PARENT_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::ecore::parent) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::ecore::parent>::value, "");

}

inline ::eo_cxx::ecore::parent::operator ::ecore::parent() const
{
   return *static_cast<::ecore::parent const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::ecore::parent::operator ::ecore::parent&()
{
   return *static_cast<::ecore::parent*>(static_cast<void*>(this));
}

inline ::eo_cxx::ecore::parent::operator ::ecore::parent const&() const
{
   return *static_cast<::ecore::parent const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore::parent >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::ecore::parent >
{
   static const int value = 0 + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::ecore::parent>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[0]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::ecore::parent >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::ecore::parent, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::ecore::parent>)
{
   return (ECORE_PARENT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_PARENT_HH

